package api

import (
	"fmt"
	"sku3dweb/db/model"
	"sku3dweb/db/repo"

	"github.com/gin-gonic/gin"
	"go.mongodb.org/mongo-driver/bson"
)

/**
db.designs.find({"editor.users":{$not:{$elemMatch:{$nin: [1,2,3]}}}, 'editor.users.0': {$exists: true}}).explain()
**/

func ParseCategory(filter []string, src []*model.ResCategory) []string {
	out := []string{}

	if len(filter) < 1 {
		for _, v := range src {
			out = append(out, v.Id.Hex())
		}
		return out
	}

	// rootCate := []string{}
	// for _, v := range src {
	// 	if v.Level == 0 {
	// 		rootCate = append(rootCate, v.Id.Hex())
	// 	}
	// }
	return out
}

func CreateLibRouter(router *GinRouter) {

	//获取款式列表
	router.GETJWT("/lib/public/design", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		page, size, query := UtilQueryPageSize(c)
		categories := query["categories"]
		if categories == nil {
			return nil, NewError("query.categories不能为空!")
		}
		strCategories := []string{}

		cates, ok := categories.([]interface{})
		if !ok {
			return nil, NewError("query.categories必须是数组!")
		}
		for _, c := range cates {
			strCategories = append(strCategories, c.(string))
		}

		designCates := []*model.ResCategory{}
		err := repo.RepoDocsSearch(apictx.CreateRepoCtx(), &repo.PageSearchOptions{CollectName: repo.CollectionLibCategory, Query: repo.Map{"type": "design"}}, &designCates)
		if err != nil {
			return nil, err
		}

		//展开当前用户team的资源授权,如果没有则为所有
		fmt.Sprintln(cates)

		if len(strCategories) > 0 {
			query["categories"] = bson.M{"$not": bson.M{"$elemMatch": bson.M{"$nin": strCategories}}}
			query["categories.0"] = bson.M{"$exists": true}
		}
		//展开待查询的cates
		//{$not:{$elemMatch:{$nin: [1,2,3]}}}, 'editor.users.0': {$exists: true}}

		return repo.RepoPageSearch(apictx.CreateRepoCtx(), &repo.PageSearchOptions{
			CollectName: repo.CollectionDesigns,
			Page:        page,
			Size:        size,
			Query:       query,
			Project:     []string{"name", "thumbnail", "createTime", "isPublic"},
		})
	})

}
