package api

import (
	"fmt"
	"sku3dweb/db/model"
	"sku3dweb/db/repo"
	"time"

	"github.com/gin-gonic/gin"
	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/bson/primitive"
	"infish.cn/comm"
)

// func NewMaterial(header *model.MaterialHeader) *model.MatConfig {
// 	uv := header.Uvtransform

// 	out := &model.MatConfig{
// 		CullFace:          "",
// 		MetalnessWorkFlow: BoolValue(true),
// 		Channels: &model.MaterialChannels{
// 			Albedo: &model.MaterailFeature{
// 				Enable:  BoolValue(true),
// 				Texture: header.BaseMap,
// 			},
// 			NormalMap: &model.MaterailFeature{
// 				Enable:  BoolValue(true),
// 				Factor:  Float64Value(1),
// 				Texture: header.NormalMap,
// 			},
// 			Roughness: &model.MaterailFeature{
// 				Enable:  BoolValue(true),
// 				Texture: header.RoughMap,
// 				Factor:  header.RoughFactor,
// 			},
// 			MetalnessPBR: &model.MaterailFeature{
// 				Enable:  BoolValue(true),
// 				Texture: header.MetalMap,
// 				Factor:  header.MetalFactor,
// 			},
// 			Emissive: &model.Emissive{
// 				Color:  model.Vect3{0, 0, 0},
// 				Factor: 1,
// 				Enable: false,
// 			},
// 			BumpMap: &model.MaterailFeature{
// 				Factor:  Float64Value(1.0),
// 				Texture: &model.OssType{},
// 			},
// 			Opacity: &model.OpacityFeature{
// 				Type:           "ALPHA_BLEND",
// 				Factor:         1,
// 				SampleChannel:  "a",
// 				RefractionTint: model.Vect3{1, 1, 1},
// 				IOR:            1,
// 				Texture:        model.OssType{},
// 			},
// 			AO:         &model.AOFeature{},
// 			SpecularF0: 0.5,
// 			ClearCoat: &model.ClearCoatFeature{
// 				Thickness: 5,
// 				Intensity: 1,
// 				Color:     model.Vect3{1, 1, 1},
// 			},
// 			Displacement: &model.MaterailFeature{
// 				Texture: header.DisplaceMap,
// 			},
// 			CavityMap: &model.MaterailFeature{},
// 		},
// 	}
// 	if uv == nil {
// 		out.Uvtransform = &model.MaterailUv{
// 			Scale:   1,
// 			Rotate:  0,
// 			OffsetX: 0,
// 			OffsetY: 0,
// 		}
// 	} else {
// 		out.Uvtransform = uv
// 	}

// 	if header.Type == "spec" {
// 		out.MetalnessWorkFlow = BoolValue(false)
// 	}

// 	if header.MetalFactor == nil {
// 		out.Channels.MetalnessPBR.Factor = Float64Value(0.0)
// 	}

// 	if header.RoughFactor == nil {
// 		out.Channels.Roughness.Factor = Float64Value(0.5)
// 	}
// 	return out
// }

func RegMatCrud(router *GinRouter) {

	//公共2d面料
	// CreateCRUD(router, "/imgmat", &CRUDOption{
	// 	Collection: repo.CollectionImageMat,
	// 	NewModel2: func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 		body := &struct {
	// 			Category   string
	// 			Category2  string
	// 			Categories []string
	// 		}{}
	// 		c.ShouldBindJSON(&body)
	// 		nopublic := false
	// 		platform := true

	// 		uid, _ := primitive.ObjectIDFromHex(apictx.User.ID)

	// 		return &model.ImageMat{
	// 			UserId:     uid,
	// 			Category:   body.Category,
	// 			Category2:  body.Category2,
	// 			Name:       "2d面料",
	// 			IsPublic:   &nopublic,
	// 			Categories: body.Categories,
	// 			Image: &model.OssType{
	// 				Url:  "",
	// 				Size: 0,
	// 			},
	// 			Platform:   &platform,
	// 			CreateTime: time.Now(),
	// 		}, nil
	// 	},
	// 	EmtyModel: func(*gin.Context) interface{} {
	// 		return &model.ImageMat{}
	// 	},
	// 	SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
	// 		return map[string]interface{}{"platform": true}
	// 	},
	// 	DetailProject: []string{"name", "image", "isPublic", "categories", "colorCards", "thumbnail"},
	// 	SearchProject: []string{"name", "image", "isPublic", "createTime", "category", "category2", "categories", "thumbnail"},
	// })

	router.POSTJWT("/upload/imgmat", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {

		body := &struct {
			ColorCards []*model.Mat2d
			Name       string
			IsPublic   bool
			Categories []string
			Thumbnail  *model.OssType
		}{}
		c.ShouldBindJSON(&body)

		if len(body.ColorCards) < 1 {
			return nil, NewError("色卡不能为空!")
		}
		platform := true
		uid, _ := primitive.ObjectIDFromHex(apictx.User.ID)
		mat := &model.ImageMat{
			UserId:     uid,
			Name:       body.Name,
			Thumbnail:  body.Thumbnail,
			IsPublic:   &body.IsPublic,
			Categories: body.Categories,
			Platform:   &platform,
			CreateTime: time.Now(),
			ColorCards: body.ColorCards,
			State:      model.LibState_Created,
		}
		return repo.RepoAddDoc(apictx.CreateRepoCtx(), repo.CollectionImageMat, mat)
	})

	router.POSTJWT("/upload/fabric", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {

		body := &struct {
			ColorCards []*comm.MaterialConf
			Name       string
			IsPublic   bool
			Categories []string
			Thumbnail  *model.OssType
		}{}
		c.ShouldBindJSON(&body)

		if len(body.ColorCards) < 1 {
			return nil, NewError("色卡不能为空!")
		}

		for _, item := range body.ColorCards {
			item.MatId = primitive.NewObjectID()
		}

		uid, _ := primitive.ObjectIDFromHex(apictx.User.ID)
		mat := &model.Fabric{
			UserId:     uid,
			Name:       body.Name,
			Thumbnail:  body.Thumbnail,
			Categories: body.Categories,
			CreateTime: time.Now(),
			ColorCards: body.ColorCards,
			State:      model.LibState_Created,
		}

		return repo.RepoAddDoc(apictx.CreateRepoCtx(), repo.CollectionFabric, mat)
	})

	//私有2d面料
	CreateCRUD(router, "/imgmat/private", &CRUDOption{
		JWT:        true,
		Collection: repo.CollectionImageMat,
		NewModel2: func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
			body := &struct {
				Name string
				Url  string
				Size int32
			}{}
			c.ShouldBindJSON(&body)
			nopublic := true
			platform := false

			uid, _ := primitive.ObjectIDFromHex(apictx.User.Parent)

			return &model.ImageMat{
				UserId:   uid,
				Name:     body.Name,
				IsPublic: &nopublic,
				Image: &model.OssType{
					Url:  body.Url,
					Size: int64(body.Size),
				},
				Platform:   &platform,
				CreateTime: time.Now(),
			}, nil
		},
		EmtyModel: func(*gin.Context) interface{} {
			return &model.ImageMat{}
		},
		SearchSort: bson.M{"createTime": -1},
		SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
			uid, _ := primitive.ObjectIDFromHex(apictx.User.ID)
			return map[string]interface{}{"userId": uid}
		},
		SearchProject: []string{"name", "image", "isPublic", "createTime", "category", "thumbnail", "colorCards"},
	})

	//材质球
	CreateCRUD(router, "/material", &CRUDOption{
		Collection: repo.CollectionMaterials,
		NewModel: func(c *gin.Context) interface{} {
			body := &struct {
				Category string
				Keyword  string
			}{}
			c.ShouldBindJSON(&body)

			now := time.Now()
			isPlatform := true
			isEffect := false

			return &model.Material{
				Category:   body.Category,
				Name:       "材质球",
				IsPlatform: &isPlatform,
				IsEffect:   &isEffect,
				Thumbnail:  &model.OssType{Url: "", Size: 0},
				CreateTime: now,
			}
		},
		EmtyModel: func(*gin.Context) interface{} {
			return &model.Material{}
		},
		SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
			return map[string]interface{}{"platform": true, "effect": false}
		},
		SearchProject: []string{"name", "thumbnail", "createTime", "category", "data", "isPublic"},
		DetailProject: []string{"name", "data", "thumbnail"},
	})

	router.GET("/specialmat/patch", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {

		out := []*model.Material{}

		err := repo.RepoSeachDocs(apictx.CreateRepoCtx(), &repo.DocSearchOptions{CollectName: repo.CollectionMaterials, Query: repo.Map{
			"platform": true,
			"effect":   true,
		}}, &out)

		total := 0

		for _, item := range out {
			m := &comm.SpecialMat{
				Id:         item.Id,
				Name:       item.Name,
				Thumbnail:  &comm.OssType{Url: item.Thumbnail.Url, Size: item.Thumbnail.Size},
				Category:   item.Category,
				CreateTime: item.CreateTime,
				Type:       "meta",
			}
			if item.Data == nil {
				continue
			}

			if item.Category == "init" {
				continue
			}

			channels := item.Data.Channels
			if channels.Albedo != nil {
				if channels.Albedo.Texture != nil {
					m.BaseMap = &comm.OssType{
						Url:  channels.Albedo.Texture.Url,
						Size: channels.Albedo.Texture.Size,
					}
				}
				if c := channels.Albedo.Color; c != nil {
					m.BaseColor = &comm.Vect3{c[0], c[1], c[2]}
				}
			}

			if channels.NormalMap != nil {
				if channels.NormalMap.Texture != nil {
					m.NormalMap = &comm.OssType{
						Url:  channels.NormalMap.Texture.Url,
						Size: channels.NormalMap.Texture.Size,
					}
				}
			}

			if channels.Opacity != nil {
				if channels.Opacity.Factor > 0 {
					f := float64(channels.Opacity.Factor)
					m.OpacFactor = &f
				}
				if len(channels.Opacity.Texture.Url) > 0 {
					m.OpacMap = &comm.OssType{Url: channels.Opacity.Texture.Url, Size: channels.Opacity.Texture.Size}
				}
			}

			if channels.Roughness != nil {
				if channels.Roughness.Texture != nil {
					m.RoughMap = &comm.OssType{Url: channels.Roughness.Texture.Url, Size: channels.Roughness.Texture.Size}
				}
				m.RoughFactor = channels.Roughness.Factor
			}

			if channels.MetalnessPBR != nil {
				if channels.MetalnessPBR.Texture != nil {
					m.MetalMap = &comm.OssType{Url: channels.MetalnessPBR.Texture.Url, Size: channels.MetalnessPBR.Texture.Size}
				}
				m.MetalFactor = channels.MetalnessPBR.Factor
			}

			if item.Data.Uvtransform != nil {
				m.Uvtransform = &comm.MaterailUv{
					Scale:   item.Data.Uvtransform.Scale,
					Rotate:  item.Data.Uvtransform.Rotate,
					OffsetX: item.Data.Uvtransform.OffsetX,
					OffsetY: item.Data.Uvtransform.OffsetY,
				}
			} else {
				m.Uvtransform = &comm.MaterailUv{
					Scale:   1,
					Rotate:  0,
					OffsetX: 0,
					OffsetY: 0,
				}
			}

			i, e := repo.RepoAddDoc(apictx.CreateRepoCtx(), "specialmats", m)
			fmt.Println(i, e)
			total += 1
		}

		return total, err
	})

	//特殊材质球
	CreateCRUD(router, "/specialmat", &CRUDOption{
		Collection: "specialmats",
		NewModel: func(c *gin.Context) interface{} {
			body := &struct {
				Category  string
				Keyword   string
				Name      string
				Thumbnail *comm.OssType
			}{}
			c.ShouldBindJSON(&body)

			return &comm.SpecialMat{
				Category:   body.Category,
				Name:       body.Name,
				Thumbnail:  body.Thumbnail,
				CreateTime: time.Now(),
			}
		},
		EmtyModel: func(*gin.Context) interface{} {
			return &comm.SpecialMat{}
		},
		SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
			return map[string]interface{}{}
		},
		DetailProject:    []string{"_id"},
		DetailProjectAll: true,
	})

	// 针车线
	CreateCRUD(router, "/linemat", &CRUDOption{
		Collection: "linemats",
		NewModel: func(c *gin.Context) interface{} {
			body := &comm.LineMat{}
			c.ShouldBindJSON(body)
			body.CreateTime = time.Now()
			return body
		},
		EmtyModel: func(*gin.Context) interface{} {
			return &comm.LineMat{}
		},
		SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
			return map[string]interface{}{}
		},
		DetailProject:    []string{"_id"},
		DetailProjectAll: true,
	})

	//面料
	CreateCRUD(router, "/fabric", &CRUDOption{
		Collection: repo.CollectionFabric,
		// NewModel2: func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		// 	body := &struct {
		// 		Category   string
		// 		Category2  string
		// 		Keyword    string
		// 		Categories []string
		// 	}{}
		// 	c.ShouldBindJSON(&body)

		// 	now := time.Now()
		// 	public := false
		// 	isPlatform := true

		// 	return &model.Fabric{
		// 		Category:   body.Category,
		// 		Category2:  body.Category2,
		// 		ColorCards: []*model.MaterialHeader{},
		// 		Categories: body.Categories,
		// 		Name:       "面料1",
		// 		Thumbnail:  &model.OssType{Url: "", Size: 0},
		// 		CreateTime: now,
		// 		IsPublic:   &public,
		// 		Price:      0,
		// 		Platform:   &isPlatform,
		// 	}, nil
		// },
		EmtyModel: func(*gin.Context) interface{} {
			return &model.Fabric{}
		},
		SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
			return map[string]interface{}{"platform": true}
		},
		noUpdate: true,

		SearchProject: []string{"name", "thumbnail", "createTime", "category", "category2", "isPublic", "colorCards", "price", "categories"},
		// DetailProject: []string{"name", "price", "thumbnail", "category", "category2", "colorCards", "categories"},
	})

	pageSearchFn := func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		page, size, query := UtilQueryPageSize(c)

		scope := c.Param("scope")
		coll := UtilGetFabricCollection(scope)

		pageOption := &repo.PageSearchOptions{
			CollectName: coll,
			Page:        page,
			Size:        size,
			Query:       query,
			Project:     []string{"name", "thumbnail", "cusNum", "createTime", "category", "colorCards", "price", "categories"},
			Sort:        bson.M{"createTime": -1},
		}
		pageResult, err := repo.RepoPageSearch(apictx.CreateRepoCtx(), pageOption)
		if err != nil {
			return nil, err
		}
		for _, v := range pageResult.List {
			if v["userId"] != nil {
				userId := v["userId"].(primitive.ObjectID).Hex()
				u, _ := repo.RedisGetUserById(apictx.CreateRepoCtx(), userId)
				if u != nil {
					v["user"] = u
				}
			}
		}
		return pageResult, nil
	}

	router.GETJWT("/fabric/list/:scope", pageSearchFn)

	router.GET("/fabric/detail/:id", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		id := c.Param("id")
		if len(id) < 1 {
			return nil, NewError("参数不能为空")
		}
		scope := c.Query("scope")
		out := &model.Fabric{}
		uid, _ := primitive.ObjectIDFromHex(id)
		Collection := UtilGetFabricCollection(scope)
		ok, err := repo.RepoSeachDoc(apictx.CreateRepoCtx(), &repo.DocSearchOptions{
			CollectName: Collection,
			Query:       repo.Map{"_id": uid},
			Project:     []string{"name", "price", "thumbnail", "category", "colorCards", "categories"},
		}, out)

		if err != nil {
			return nil, err
		}
		if !ok {
			return nil, NewError("没有查询到数据")
		}
		return out, nil
	})

	router.POSTJWT("/fabric/update/:scope", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {

		fabric := &model.Fabric{}
		err := c.ShouldBindJSON(fabric)
		if err != nil {
			fmt.Println(err)
			return nil, NewError("参数解析错误")
		}

		collection := UtilGetFabricCollection(c.Param("scope"))
		if fabric.Id == primitive.NilObjectID {
			return nil, NewError("Id不能为空!")
		}
		id := fabric.Id.Hex()
		if len(fabric.ColorCards) > 0 {
			for _, item := range fabric.ColorCards {
				if item.MatId == primitive.NilObjectID {
					item.MatId = primitive.NewObjectID()
				}
			}
		}

		// if len(fabric.ColorCards) > 0 { //更新色卡, 更新对应的材质球Id
		// 	oldFabric := &model.Fabric{}
		// 	ok, _ := repo.RepoSeachDoc(apictx.CreateRepoCtx(), &repo.DocSearchOptions{CollectName: collection, Query: repo.Map{"_id": id}, Project: []string{"colorCards"}}, oldFabric)
		// 	if ok {
		// 		// oldLen := len(oldFabric.ColorCards)
		// 		oldMatIds := map[string]bool{}

		// 		findCard := func(id string) *model.MaterialHeader {
		// 			for _, c := range oldFabric.ColorCards {
		// 				if c.MatId.Hex() == id {
		// 					return c
		// 				}
		// 			}
		// 			return nil
		// 		}

		// 		for _, mat := range fabric.ColorCards {

		// 			//没有ID 新增
		// 			if mat.MatId == primitive.NilObjectID {
		// 				matItem := &model.Material{
		// 					Category:   "fabric",
		// 					Name:       mat.Name,
		// 					IsPlatform: BoolValue(false),
		// 					IsEffect:   BoolValue(false),
		// 					Thumbnail:  mat.Thumbnail,
		// 					Data:       NewMaterial(mat),
		// 					CreateTime: time.Now(),
		// 				}
		// 				ret, _ := repo.RepoAddDoc(apictx.CreateRepoCtx(), repo.CollectionMaterials, matItem)
		// 				mat.MatId, _ = primitive.ObjectIDFromHex(ret)
		// 				continue
		// 			}
		// 			//有判断是更新还是删除
		// 			old := findCard(mat.MatId.Hex())
		// 			if old != nil { //找到了判断是否更新
		// 				oldMatIds[old.MatId.Hex()] = true
		// 				noChanged := mat.IsEqual(old)
		// 				if noChanged {
		// 					continue
		// 				}
		// 				//更新
		// 				material := NewMaterial(mat)
		// 				matRet, _ := repo.RepoUpdateSetDocProps(apictx.CreateRepoCtx(), repo.CollectionMaterials, mat.MatId.Hex(), bson.M{"$set": bson.M{"data": material}})
		// 				fmt.Sprintln(matRet)
		// 			}
		// 		}
		// 		//删除旧的
		// 		for _, oldCard := range oldFabric.ColorCards {
		// 			if oldCard.MatId == primitive.NilObjectID {
		// 				continue
		// 			}

		// 			id := oldCard.MatId.Hex()
		// 			if !oldMatIds[id] {
		// 				removeRet, _ := repo.RepoDeleteDoc(apictx.CreateRepoCtx(), repo.CollectionMaterials, id)
		// 				fmt.Sprintln("==removeRet===")
		// 				fmt.Sprintln(removeRet)
		// 			}
		// 		}
		// 	}
		// }
		return repo.RepoUpdateSetDoc(apictx.CreateRepoCtx(), collection, id, fabric)
		// if err != nil {
		// 	return nil, err
		// }
		// if out.MatchedCount != 1 {
		// 	return nil, NewError("文件不存在!")
		// }
		// if out.ModifiedCount != 1 {
		// 	return nil, NewError("更新失败!")
		// }
	})

	//私有2d面料
	router.GETJWT("/fabric/private/list", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		page, size, query := UtilQueryPageSize(c)

		query["userId"] = apictx.User.ID
		pageOption := &repo.PageSearchOptions{
			CollectName: repo.CollectionFabric,
			Page:        page,
			Size:        size,
			Query:       query,
			Project:     []string{"name", "createTime", "categories", "thumbnail", "colorCards"},
		}
		pageOption.Sort = bson.M{"createTime": -1}

		pageResult, err := repo.RepoPageSearch(apictx.CreateRepoCtx(), pageOption)
		if err != nil {
			return nil, err
		}
		return pageResult, nil
	})

	router.GET("/dadongfabricpatch", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		//db.fabric_company.find({"name":{"$regex":"dd-"}})
		var fabrics = []*model.Fabric{}

		err := repo.RepoSeachDocs(apictx.CreateRepoCtx(), &repo.DocSearchOptions{
			CollectName: "fabric_company",
			Query:       repo.Map{"name": bson.M{"$regex": "dd-"}},
		}, &fabrics)

		total := 0

		for _, item := range fabrics {

			item.Categories = []string{"62469386cd23c798d0d20a4a"}
			item.UserId, _ = primitive.ObjectIDFromHex(DADONG_USER_ID)
			item.Id = primitive.NilObjectID
			item.CompanyId = DADONG_USER_ID
			item.State = model.LibState_Publish2Qiye
			_, err := repo.RepoAddDoc(apictx.CreateRepoCtx(), "fabric_company", item)
			if err == nil {
				total += 1
			}
		}

		return total, err
	})
}
